package no.ntnu.trec.kba;

/**
 * Created by NT.
 * User: takhirov
 * Date: 9/8/12
 * Time: 11:23 PM
 */

import streamcorpus.StreamItem;
import org.apache.hadoop.io.Writable;
import org.apache.hadoop.io.WritableUtils;
import org.apache.thrift.TDeserializer;
import org.apache.thrift.TException;
import org.apache.thrift.TSerializer;
import org.apache.thrift.protocol.TBinaryProtocol;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

public class StreamItemWritable extends StreamItem implements Writable {

    private static final long serialVersionUID = 1L;

    TSerializer serializer = new TSerializer(new TBinaryProtocol.Factory());
    TDeserializer deserializer = new TDeserializer(new TBinaryProtocol.Factory());

    /** Deserializes this object.*/
    public void write(DataOutput out) throws IOException {
        try {
            byte[] bytes = serializer.serialize(this);
            WritableUtils.writeVInt(out, bytes.length);
            out.write(bytes, 0, bytes.length);
        } catch (TException e) {
            e.printStackTrace();
            throw new IOException(e);
        }

    }

    /** Serializes this object. */
    public void readFields(DataInput in) throws IOException {
        try {
            int length = WritableUtils.readVInt(in);
            byte[] bytes = new byte[length];
            in.readFully(bytes, 0, length);
            deserializer.deserialize(this, bytes);

        } catch (TException e) {
            e.printStackTrace();
            throw new IOException(e);
        }

    }

}
