package no.ntnu.trec.kba.features;

import java.io.IOException;
import java.text.ParseException;
import java.util.HashMap;

import no.ntnu.trec.kba.StreamDocument;
import no.ntnu.trec.kba.TopicEntity;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.lucene.document.Document;

/**
 * Abstract class for generating a particular set of features for a given
 * stream_id-urlname pair.
 * 
 * @author Krisztian Balog <krisztian.balog@idi.ntnu.no>
 */
public abstract class FeatureGenerator {
	protected Configuration config = null;

	public FeatureGenerator(Configuration config) throws IOException {
		this.config = config;
	}

	public abstract String getFeatureVector(StreamDocument doc, TopicEntity entity) throws IOException;


}
