package no.ntnu.trec.utils.dbpedia;

import java.util.HashSet;

/**
 * Abstract class for processing a Subject-Predicate-Object triple
 *
 * @author Krisztian Balog <krisztian.balog@uis.no>
 */
public abstract class SPOProcessor {

	HashSet<String> entities;
	
	public void setEntities(HashSet<String> entities) {
		this.entities = entities;
	}
	
	public static String entityFromURI(String uri) {
		return uri.replace("http://dbpedia.org/resource/", "");
	}
	
	public abstract String process(String subject, String predicate, String object);
}
