package no.ntnu.utils;

import net.sf.extjwnl.JWNLException;
import net.sf.extjwnl.dictionary.Dictionary;
import org.apache.lucene.analysis.shingle.ShingleFilter;
import org.apache.lucene.analysis.standard.StandardTokenizer;
import org.apache.lucene.analysis.tokenattributes.CharTermAttribute;
import org.apache.lucene.util.Version;

import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

public class NGramHelper {
    public static List<String> getShingles(String raw, int minSize, int maxSize) throws IOException {
        ArrayList<String> list = new ArrayList<String>();
        StringReader reader = new StringReader(raw);
        ShingleFilter tok = new ShingleFilter(new StandardTokenizer(Version.LUCENE_42, reader), minSize, maxSize);
        CharTermAttribute termAttr = tok.addAttribute(CharTermAttribute.class);
        tok.reset();
        while (tok.incrementToken()) {
            String term = termAttr.toString();

            list.add(term);
        }

        tok.close();
        return list;
    }


}
