package no.ntnu.utils.classification;

import java.io.*;
import java.util.zip.GZIPOutputStream;

/**
 * Produces runfile in format of TREC KBA 2014
 *
 * @author Christian Barth Roligheten <chrbarrol@gmail.com>
 *
 */

public class TrecKBARunWriter {
    private OutputStreamWriter _writer;

    public static final String RUN_HEADER = "#{\"team_id\": \"team\", \"system_id\": \"ccr\", \"task_id\": \"kba-ccr-2014\"}\n";

    public TrecKBARunWriter(String outputDir, String teamName, String runName) throws IOException {
        _writer = new OutputStreamWriter(new GZIPOutputStream(new FileOutputStream(outputDir + "/" + teamName + "-" + runName + ".gz")));
        _writer.write(RUN_HEADER);
    }

    public void writeJudgement(String documentTopicIdPair, Integer confidence, Integer rating) throws IOException {
        String lineBuf = "ntnu\tntnu_sys\t"
                + documentTopicIdPair + "\t"
                + confidence + "\t"
                + rating + "\t1\t0000-00-00-00\tNULL\tX\t0-0\n";

        _writer.write(lineBuf);
    }

    public void close() throws IOException {
        _writer.close();
    }
}
