import sys
from argparse import ArgumentParser
import ccr

def main():
    parser = ArgumentParser(description='Perform vital filtering on features stored in libsvm format, output runfile in format for CCR task')
    parser.add_argument('--train', help='Path to training libsvm file. For LTR score partitions are expected in .scores file in same dir', required=True)
    parser.add_argument('--test', help='Path to test libsvm file, For LTR score partitions are expected in .scores file in same dir', required=True)
    parser.add_argument('--dependent', help='If training/prediction should be done entity-dependent', action='store_true')
    parser.add_argument('--print_importance', help='If feature importance should be printed', action='store_true')
    parser.add_argument('--method', choices=['ltr', 'msc'], required=True)
    parser.add_argument('--runname', default='ntnu-ccr.txt')


    args = parser.parse_args()
    print('Arguments: ' + str(args))

    if (args.method == 'ltr'):
        ccr.ltr.run(args)
    else:
        print("Error: LTR is the only implemented ranking approach")

if __name__ == '__main__':
    main()
